# Frontle Modal

> Modal UI in Frontle
>

![화면-기록-2022-07-12-오후-3.40.17](https://user-images.githubusercontent.com/49587288/197337429-6fe44f6f-c06d-42ff-a7f4-d3e67b725c29.gif)

## Usage

```javascript
// at css file
.modalPosition{
    position: absolute;
}
.contentsWidth{
    width: 80%;
}
.contentsHeight{
    height: 200px;
}

// at js file
import frontle_modal from "browser_modules/frontle-modal/module.js";
const Modal = frontle_modal.Modal;

let modal = new Modal('<button id="closeButton">close</button>');
modal.modalClass = 'modalPosition';
modal.modalContentsClass = 'contentsWidth contentsHeight';
modal.modalBackgroundClass = '';
modal.start = () => {
    console.log('modal start!');

    document.getElementById('closeButton').onclick = () => {
        modal.close();
    }
}
modal.open();
```

## Install

**Frontle**

```shell
frontle install frontle-modal
```

**Download files**

https://github.com/Artifriends-inc/Frontle-Modal

## API

#### new modal(html)

Create a modal object

```javascript
let modal = new Modal('<button id="closeButton">close</button>');
```

#### .modalClass

#### .modalContentsClass

#### .modalBackgroundClass

Set the css class of a modal

```javascript
modal.modalClass = 'modalPosition';
modal.modalContentsClass = 'contentsWidth contentsHeight';
modal.modalBackgroundClass = '';
```

#### .transitionSeconds

Set the modal animation time

```javascript
modal.transitionSeconds = 0.3;
```

#### .backgroundClickExit

Set whether modal can be closed by clicking on modal background

```javascript
modal.backgroundClickExit = true;
```

#### .awake

This lifecycle runs before modal rendering.

```javascript
modal.awake = () => { console.log('before rendering') }
```

#### .start

This lifecycle runs after modal rendered

```javascript
modal.start = () => { console.log('after rendering') }
```

#### .end

This lifecycle runs before modal termination

```javascript
modal.end = () => { console.log('before termination') }
```

#### .sleep

This lifecycle runs after modal termination

```javascript
modal.sleep = () => { console.log('after termination') }
```

#### .open()

Open modal

```javascript
modal.open();
```

#### .close()

Close modal

```javascript
modal.close();
```

## People

The original author of frontle-modal is [MushStory](https://github.com/MushStory)

## License

 [MIT](LICENSE)
